#!/usr/bin/python
import sys
import vxi11
import time
import numpy as np

log_name = "icl_test182m_3245_1ma_diyx1r.csv"

#fluke = vxi11.Instrument("192.168.1.125", "gpib0,1") # Fluke 5720A, GPIB Address = 1
#fluke.timeout = 30
#fluke.clear()
#fluke.write("*IDN?")
#print "Source detected = %s" % fluke.read()

#dmm = vxi11.Instrument("192.168.1.125", "gpib0,3") # Keysight 3458A, GPIB Address = 1
#dmm.timeout = 30
#dmm.clear()
#dmm.write("ID?")
#print "DUT1 detected = %s" % dmm.read()

#dmm2 = vxi11.Instrument("192.168.1.125", "gpib0,2") # Keysight 3458A, GPIB Address = 1
#dmm2.timeout = 30
#dmm2.clear()
#dmm2.write("ID?")
#print "DUT2 detected = %s" % dmm2.read()

#dmm3 = vxi11.Instrument("192.168.1.125", "gpib0,5") # Fluke 8508A, GPIB Address = 1
#dmm3.timeout = 30
#dmm3.clear()
#dmm3.write("*IDN?")
#print "DUT3 detected = %s" % dmm3.read()

#dmm4 = vxi11.Instrument("192.168.1.125", "gpib0,6") # Fluke 8508A, GPIB Address = 1
#dmm4.timeout = 30
#dmm4.clear()
#dmm4.write("*IDN?")
#print "DUT4 detected = %s" % dmm4.read("*IDN?")

nvm1 = vxi11.Instrument("192.168.1.127", "gpib0,18") # Keithley 182M -  18
nvm1.timeout = 30
#nvm1.clear()
nvm1.write("L1X")
nvm1.write("I0X")
nvm1.write("B1F0G0O1P1N1W0R1S2T5Z0X")
#print "DUT4 detected = %s" % dmm4.read("*IDN?")

rstd = 1.00005684
print "DUT configured, starting ACAL"

#dmm3.write("*TRG;GET;RDG?") # Get reading
#dmm3.read()
print "DUTs is nulled to MFC zero"

def create_local_file(log_name):
    if (os.path.isfile(log_name) == False):
        with open(log_name, 'a') as o:
	    o.write ("date;source;duta;dutb;dutc;dutd;sdev;sdev2;sdev3;sdev4;temp;temp2\r\n")
            print ("\033[2;40H-i- DataFile %s does not exist\r\n" % log_name)
    else:
        print ("\033[2;40H-i- Datafile %s exists\r\n" % log_name)
    o.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name

for i in range(-100,100,1):
    median = 0.0
    sdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    median3 = 0.0
    sdev3 = 0.0
    array3 = []
    median4 = 0.0
    sdev4 = 0.0
    array4 = []
    set_value = (float(i) / 10000)
    #fluke.write("OUT %.7g A" % set_value)
    #print ("OUT %.7g A" % set_value)
    #fluke.write("OPER")
    #time.sleep(10)
    for ix in range (0,10): #take more samples
	nvm1.write("X")
	val = float(nvm1.read())
	#dmm2.write("TARM SGL")
	val2 = val / rstd  #float(dmm2.read())
	#dmm3.write("*TRG;GET;RDG?")
	val3 = 0#float(dmm3.read())
	#dmm4.write("READ?")
	val4 = 0#float(dmm4.read())
	array.extend([val])
	array2.extend([val2])
	array3.extend([val3])
	array4.extend([val4])
	if abs(set_value) >= 0.0000005:
	    print("\033[33;1m A %.8e, ppm %.4f \033[35;1m B %.8e, ppm %.4f \033[37;1m C %.8e, ppm %.4f \033[32;1m D %.8e, ppm %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6) ))
    	if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
	    print ("Smoke escaped, check connections")
	    #fluke.write("OUT 0 A")
	    #fluke.write("STBY")
	    quit()
    sdev = np.std(array[2:])
    median = np.median(array[2:])
    sdev2 = np.std(array2[2:])
    median2 = np.median(array2[2:])
    sdev3 = np.std(array3[2:])
    median3 = np.median(array3[2:])
    sdev4 = np.std(array4[2:])
    median4 = np.median(array4[2:])
    if abs(float(i) / 10) >= 0.0000005:
	dev1 = ((median / set_value - 1) * 1e6)
	dev2 = ((median2 /set_value - 1) * 1e6)
	dev3 = ((median3 /set_value - 1) * 1e6)
	dev4 = ((median4 /set_value - 1) * 1e6)
	print("\033[32;1mSRC %.4f \033[33;1A %.9e, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9e, sdev5 = %.3f uV, med5 = %.8e \033[34;1m Delta %.4f ppm \033[37;1mC %.9e, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9e, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
        #dmm.write("DISP MSG,'%5.3f %2.1fV" % (dev1,set_value ))
        #dmm2.write("DISP MSG,'%5.3f %2.1fV" % (dev2,set_value ))
    #dmm.write("TEMP?")
    temp = 24#float(dmm.read())
    #dmm2.write("TEMP?")
    temp2 = 24#float(dmm2.read())
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%.4f;%.9e;%.9e;%.9e;%.9e;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, median, median2, median3, median4, sdev, sdev2, sdev3, sdev4, temp, temp2)))
    dile.close()

#fluke.write("STBY")
#fluke.write("OUT 0 V")
#fluke.write("RANGELCK OFF")
#dmm.write("RESET")
#dmm2.write("RESET")
#dmm3.write("*RST")
#dmm4.write("RESET")
